unit Main_Form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SQLite3, SQLiteTable3, StdCtrls, ComCtrls, XPMan;

type
  TMainForm = class(TForm)
    XPManifest1: TXPManifest;
    List_Base: TListView;
    add_group: TGroupBox;
    fio_edit: TEdit;
    tel_edit: TEdit;
    add_btn: TButton;
    edit_btn: TButton;
    find_group: TGroupBox;
    parametr: TComboBox;
    find_edit: TEdit;
    find_btn: TButton;
    create_btn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure List_BaseKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure add_btnClick(Sender: TObject);
    procedure edit_btnClick(Sender: TObject);
    procedure List_BaseClick(Sender: TObject);
    procedure List_BaseKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure find_btnClick(Sender: TObject);
    procedure find_editKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure create_btnClick(Sender: TObject);
  private
    { Private declarations }
  public
  sql:TSQLiteDatabase;
  Procedure Find(Index:integer; str:string);
  Procedure Edit_Item(fio, tel:string);
  Procedure Add_Item(fio, tel:string);
  Procedure Load_Users;
  Procedure Del_Item;

    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

Procedure TMainForm.Find(Index:Integer; str:string);
Var
  sql_tb:TSQLiteTable;
  i:Integer;
Begin
if Index=0 then
begin
  sql_tb:=sql.GetTable('SELECT fio,tel FROM users WHERE fio LIKE "%'+Utf8Encode(find_edit.Text+'%"'));
end;
///
  List_Base.Clear;
  List_Base.Items.BeginUpdate;
  if sql_tb.Count > 0 then
  begin
  for i:=0 to sql_tb.Count - 1 do
  begin
    Application.ProcessMessages;
    with List_Base.Items.Add do
    begin
      Caption:=utf8decode(sql_tb.FieldAsString(0));
      SubItems.Add(utf8decode(sql_tb.FieldAsString(1)));
    end;
    sql_tb.Next;
  end;
  end;
  List_Base.Items.EndUpdate;
  sql_tb.Free;
End;

Procedure TMainForm.Load_Users;
Var
  sql_tb:TSQLiteTable;
  i:integer;
Begin
  List_Base.Clear;
  List_Base.Items.BeginUpdate;
  sql_tb:=sql.GetTable('SELECT fio, tel FROM users');
  if sql_tb.Count > 0 then
  begin
  for i:=0 to sql_tb.Count - 1 do
  begin
    Application.ProcessMessages;
    with List_Base.Items.Add do
    begin
      Caption:=utf8decode(sql_tb.FieldAsString(0));
      SubItems.Add(utf8decode(sql_tb.FieldAsString(1)));
    end;
    sql_tb.Next;
  end;
  end;
  List_Base.Items.EndUpdate;
  sql_tb.Free;
End;

Procedure TMainForm.Add_Item(fio, tel:string);
Begin
  sql.ExecSQL('INSERT INTO users (fio, tel) VALUES ("'+utf8encode(fio)+'","'+utf8encode(tel)+'")');
End;

Procedure TMainForm.Del_Item;
Begin
  sql.ExecSQL('DELETE FROM users WHERE id='+IntToStr(List_Base.ItemIndex+1));
End;

Procedure TMainForm.Edit_Item(fio, tel:string);
Begin
  sql.ExecSQL('UPDATE users SET fio="'+utf8encode(fio)+'",'+'tel="'+tel+'"'+' WHERE id='+IntToStr(List_Base.ItemIndex+1));
End;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  if FileExists(ExtractFilePath(Application.ExeName)+'my_base.db') = True then
  begin
    sql:=TSQLiteDatabase.Create('my_base.db');
    if sql.TableExists('users') then Load_Users;
    if List_Base.Items.Count > 0 then
    begin
      List_Base.ItemIndex:=0;
      List_BaseClick(Sender);
    end;
  end;

end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  sql.Free;
end;

procedure TMainForm.List_BaseKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if (KEY = VK_DELETE) and (List_Base.Items.Count > 0) then
begin
  if (MessageBox(	Handle, PChar(' ,       ?'),
      PChar(Application.Title), MB_ICONQUESTION or MB_YESNO) = ID_YES) then
  begin
    Del_Item;
    Load_Users;
  end;
end;
end;

procedure TMainForm.add_btnClick(Sender: TObject);
begin
  Add_Item(fio_edit.Text, tel_edit.Text);
  Load_Users;
end;

procedure TMainForm.edit_btnClick(Sender: TObject);
var
  Index:Integer;
begin
try
  Index:=List_Base.ItemIndex;
  Edit_Item(fio_edit.Text, tel_edit.Text);
  Load_Users;
  List_Base.ItemIndex:=Index;
  List_BaseClick(Sender);
except
end;
end;

procedure TMainForm.List_BaseClick(Sender: TObject);
begin
try
  if List_Base.Items.Count > 0 then
  begin
    fio_edit.Text:=List_Base.Items[List_Base.ItemIndex].Caption;
    tel_edit.Text:=List_Base.Items[List_Base.ItemIndex].SubItems.Strings[0];
  end;
except
end;
end;

procedure TMainForm.List_BaseKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if (KEY = VK_UP) or (KEY = VK_DOWN) and (List_Base.Items.Count > 0) then
begin
  try
  if List_Base.Items.Count > 0 then
  begin
    fio_edit.Text:=List_Base.Items[List_Base.ItemIndex].Caption;
    tel_edit.Text:=List_Base.Items[List_Base.ItemIndex].SubItems.Strings[0];
  end;
except
end;
end;
end;

procedure TMainForm.find_btnClick(Sender: TObject);
begin
  Find(parametr.ItemIndex, find_edit.Text);
end;

procedure TMainForm.find_editKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if KEY = VK_RETURN then find_btnClick(Sender);
end;

procedure TMainForm.create_btnClick(Sender: TObject);
var
  sldb:TSQLiteDatabase;
begin
  sldb := TSQLiteDatabase.Create('test.db');
  try
    sldb.ExecSQL('CREATE TABLE Users (id INTEGER PRIMARY KEY, fio TEXT, tel INTEGER)');
    showmessage(' !');
  except
    showmessage('  '+Pchar(GetLastError));
  end;
  sldb.Free;
end;

end.
